#include <ESP8266WiFi.h>
#define MAX_SRV_CLIENTS 3   //Maximum number of connection at the same time, the number of devices you want to access, 8266 tcpserver access only five
 
const char *ssid = "Elecrow803"; //Here is my wifi, you shold modifi to you when you use wi-fi ssid to connect
const char *password = "elecrow2014"; //Here is my wif password,you should use wifi password of yours
 
WiFiServer server(8266);//Your port, modify, the range of 0-65535
WiFiClient serverClients[MAX_SRV_CLIENTS];


#define water_PIN 4

#define tem_PIN 5

int n=0;
WiFiClient client;





#define uv_PIN A0


int b,bb,bbb,bbbb,bbbbb,bbbbbb,bbbbbbb;

 
void setup()
{
    Serial.begin(115200);
    delay(10);
    pinMode(16, OUTPUT);
    digitalWrite(16, 0);
    WiFi.begin(ssid, password);
 
    while (WiFi.status() != WL_CONNECTED)
    {
        delay(500);
    }
     Serial.println("WiFi connected");
    Serial.println("IP address: ");
    Serial.println(WiFi.localIP());//WiFi. LocalIP () return 8266 IP addresses

    server.begin();
    server.setNoDelay(true);  //Combined with normal only after some

     pinMode(water_PIN, INPUT);
     //digitalWrite(water_PIN,HIGH);
    // pinMode(tem_PIN, OUTPUT);
     pinMode(uv_PIN, INPUT);


     
}
 
void loop()
{
    //blink();



int temp;//   temperature
int humi;//   humidity
int tol;//  Check code
int j;
unsigned int loopCnt;
int chr[40] = {0};//Create an array of Numbers, used to store 40 bit
unsigned long time1;
  bgn:
  delay(2000);
//The output low level 20 ms (> 18 ms)
//A 40 mu s output level
  pinMode(tem_PIN,OUTPUT);
  digitalWrite(tem_PIN,LOW);
  delay(20);
  digitalWrite(tem_PIN,HIGH);
  delayMicroseconds(40);
  digitalWrite(tem_PIN,LOW);
  pinMode(tem_PIN,INPUT);
  //High level response signal
  loopCnt=10000;
  while(digitalRead(tem_PIN) != HIGH)
  {
    if(loopCnt-- == 0)
    {
//If long time don't return to the high level, the output a hint, start over.
      Serial.println("HIGH");
      goto bgn;
    }
  }
  //Low level response signal
  loopCnt=30000;
  while(digitalRead(tem_PIN) != LOW)
  {
    if(loopCnt-- == 0)
    {
//If long time don't return to the low level, the output a hint, start over.
      Serial.println("LOW");
      goto bgn;
    }
  }
//Began to read the bit1-40
    for(int i=0;i<40;i++)
  {
    while(digitalRead(tem_PIN) == LOW)
    {}
//When there is a high electricity at ordinary times, take time to "time"
    time1 = micros();
    while(digitalRead(tem_PIN) == HIGH)
    {}
//When there is a low level, write down the time, minus the storage time just now
//It is concluded that if the value of more than 50 mu s, it is' 1 ', or as' 0 '
//And stored into an array
    if (micros() - time1  >50)
    {
      chr[i]=1;
    }else{
      chr[i]=0;
    }
  }
    
//Humidity, eight bit, converted into numerical values
humi=chr[0]*128+chr[1]*64+chr[2]*32+chr[3]*16+chr[4]*8+chr[5]*4+chr[6]*2+chr[7];
    
//Temperature, 8 bit, converted into numerical values
temp=chr[16]*128+chr[17]*64+chr[18]*32+chr[19]*16+chr[20]*8+chr[21]*4+chr[22]*2+chr[23];
  //Check code, 8 bit, converted into numerical values
//tol=chr[32]*128+chr[33]*64+chr[34]*32+chr[35]*16+chr[36]*8+chr[37]*4+chr[38]*2+chr[39];
//Output: temperature, humidity, proofreading yards
//  Serial.print("temp:");
//  Serial.println(temp);
  String str1="mode=up&apikey=674c0a5616458361&data={ck001002";
  str1+=temp;
  str1+=".";
  str1+=humi;
  str1+="}\r\n";
  //client.print(str1);
  //Serial.print(str1);
  Serial.print("temp:");
  Serial.println(temp);
  bb=temp;
  Serial.print("humi:");
  Serial.println(humi);
  bbb=humi;
  







    
    static long previousMillis = 0;
    static int currstate = 0;
  
    if (millis() - previousMillis > 200)  //200ms
    {
        previousMillis = millis();
        currstate = 1 - currstate;
        digitalWrite(16, currstate);
         b=analogRead(A0);
         Serial.println(b);
         
         //Serial.println(bb);
    }
 
    uint8_t i;
    if (server.hasClient())
    {
        for (i = 0; i < MAX_SRV_CLIENTS; i++)
        {
            if (!serverClients[i] || !serverClients[i].connected())
            {
                if (serverClients[i]) serverClients[i].stop();//Not join, release
                serverClients[i] = server.available();//Assign a new
                continue;
            }
 
        }
        WiFiClient serverClient = server.available();
        serverClient.stop();
    }
    for (i = 0; i < MAX_SRV_CLIENTS; i++)
    {
        if (serverClients[i] && serverClients[i].connected())
        {
            digitalWrite(16, 0);//There is a link, has been long bright
 
            if (serverClients[i].available())
            {
                while (serverClients[i].available()) 
                    Serial.write(serverClients[i].read());
            }
        }
    }
    //if (Serial.available())
   
        //size_t len = Serial.available();
        //uint8_t sbuf[len];
        size_t s=8;
        uint8_t buff[s];

         int a;
      //   a=digitalRead(water_PIN);
         buff[0]='R';
       if(digitalRead(water_PIN)==HIGH)
       {
        buff[1]='1';
        }
        else
        {
          buff[1]='0';
        }
        
       
         
        if(b>450)
        {
          buff[2]='6';
        }
        else
        {
          buff[2]='9';
        }
       

        
        bbbb=bbb/10;
        if(bbbb==0)
        {
          buff[3]='A';
        }
        if(bbbb==1)
        {
          buff[3]='B';
        }
        if(bbbb==2)
        {
          buff[3]='C';
        }
        if(bbbb==3)
        {
          buff[3]='D';  
        }
        if(bbbb==4)
        {
          buff[3]='E';
        }
        if(bbbb==5)
        {
           buff[3]='F';
        }
        if(bbbb==6)
        {
          buff[3]='G';
        }
        if(bbbb==7)
        {
          buff[3]='H';
        }
        if(bbbb==8)
        {
          buff[3]='I';
        }   
        if(bbbb==9)
        {
          buff[3]='J';
        }             
        bbbbb=bbb%10;
        if(bbbbb==0)
        {
          buff[4]='a';
        }
        if(bbbbb==1)
        {
          buff[4]='b';
        }
        if(bbbbb==2)
        {
          buff[4]='c';    
        }
        if(bbbbb==3)
        {
          buff[4]='d';  
        }
        if(bbbbb==4)
        {
          buff[4]='e';  
        } 
        if(bbbbb==5)
        {
          buff[4]='f';  
        }               
        if(bbbbb==6)
        {
          buff[4]='g';  
        }        
        if(bbbbb==7)
        {
          buff[4]='h';  
        }    
        if(bbbbb==8)
        {
          buff[4]='i';  
        } 
        if(bbbbb==9)
        {
          buff[4]='j';  
        }   
                    
//        
       // buff[0]=a;
        //buff[1]='1';
        //buff[2]='c';
        //buff[3]='d';
        //Serial.readBytes(sbuf, len);
        bbbbb=bb/10;
        if(bbbbb==0)
        {
          buff[5]='K';
        }
        if(bbbbb==1)
        {
          buff[5]='L';
        }
        if(bbbbb==2)
        {
          buff[5]='M';
        }
        if(bbbbb==3)
        {
          buff[5]='N';  
        }
        if(bbbbb==4)
        {
          buff[5]='O';
        }
        if(bbbbb==5)
        {
           buff[5]='P';
        }
        if(bbbbb==6)
        {
          buff[5]='Q';
        }
        if(bbbbb==7)
        {
          buff[5]='U';
        }
        if(bbbbb==8)
        {
          buff[5]='S';
        }   
        if(bbbbb==9)
        {
          buff[5]='T';
        }
        
        bbbbbb=bb%10;
        if(bbbbbb==0)
        {
          buff[6]='k';
        }
        if(bbbbbb==1)
        {
          buff[6]='l';
        }
        if(bbbbbb==2)
        {
          buff[6]='m';
        }
        if(bbbbbb==3)
        {
          buff[6]='n';  
        }
        if(bbbbbb==4)
        {
          buff[6]='o';
        }
        if(bbbbbb==5)
        {
           buff[6]='p';
        }
        if(bbbbbb==6)
        {
          buff[6]='q';
        }
        if(bbbbbb==7)
        {
          buff[6]='r';
        }
        if(bbbbbb==8)
        {
          buff[6]='s';
        }   
        if(bbbbbb==9)
        {
          buff[6]='t';
        }
         buff[7]='Z';    


        
        //push UART data to all connected telnet clients
        for (i = 0; i < MAX_SRV_CLIENTS; i++)
        {
            if (serverClients[i] && serverClients[i].connected())
            {
               // serverClients[i].write(sbuf, len);  //To all the client sends data
               serverClients[i].write(buff,s);
               //delay();
            }
        }


        
        void uv();
    }

 
 
//void blink()
//{
//    static long previousMillis = 0;
//    static int currstate = 0;
// 
//    if (millis() - previousMillis > 200)  //200ms
//    {
//        previousMillis = millis();
//        currstate = 1 - currstate;
//        digitalWrite(16, currstate);
//    }
//}


















void uv()
{
  //int uvLevel = averageAnalogRead(uv_PIN);
  int uvLevel = analogRead(uv_PIN);
  //int refLevel = averageAnalogRead(REF_3V3);
  int refLevel=1023;
  //Use the 3.3V power pin as a reference to get a very accurate output value from sensor
  int outputVoltage = 3.3 / refLevel * uvLevel;
  int v;
  v=outputVoltage;
//  Serial.println(v);
//            size_t u=1;
//        uint8_t buff2[u];
//
//
//        
//        buff2[u]=v;
//
//
//        int i;
//        for (i = 0; i < MAX_SRV_CLIENTS; i++)
//        {
//            if (serverClients[i] && serverClients[i].connected())
//            {
//               // serverClients[i].write(sbuf, len);  //向所有客户端发送数据
//               serverClients[i].write(buff2,u);
//               delay(1);
//            }
//        }
}

//Takes an average of readings on a given pin
//Returns the average







  
